@echo off
Rem Definici de variables 
set PATH_ACTUAL=%~dp0
set RUTA_SELECTS=%PATH_ACTUAL%scripts\selects
set ORACLE_HOME=
set SYSTEM_PASSWORD=
set USUARI_BD=
set SID_BD=
set PARTICIONAR_TAULES=N
set SCRIPT_CREACIO_TAULES=%PATH_ACTUAL%scripts\taules
set SCRIPT_CREACIO_PAQUETS=%PATH_ACTUAL%scripts\paquets\scripts_paquets.sql
set SCRIPT_DIR_BD=%PATH_ACTUAL%scripts\directoris_bd\directoris_bd.sql
set SCRIPT_PARAMETRES=%PATH_ACTUAL%scripts\parametres\ins_parametres.sql
set SCRIPT_CREACIO_VISTES=%PATH_ACTUAL%scripts\vistes\scripts_vistes.sql
set SCRIPT_RECOMPILAR_PAQUETS=%PATH_ACTUAL%scripts\paquets\recompilar.sql
set SCRIPT_CREACIO_USUARI=%PATH_ACTUAL%scripts\usuari\usuari.sql
set SCRIPT_CREACIO_DISPARADORS=%PATH_ACTUAL%scripts\disparadors\scripts_disparadors.sql
set TABLESPACE_TAULES=
set TABLESPACE_INDEXS=
set TABLESPACE_PARTICIONS=
set LOG_INSTALACIO=%PATH_ACTUAL%scripts\instalacio.log

cd %PATH_ACTUAL%

Rem Aspectes configurables per part de l' usuari 
set /p ORACLE_HOME=Indiqui la ruta d' instal.lacio base del client Oracle (ORACLE_HOME): 
rem Es verifica si en la ruta informada existeix el SQLPLUS
set DIR_SQLPLUS=%ORACLE_HOME%\bin\sqlplus.exe
dir %DIR_SQLPLUS% >> %LOG_INSTALACIO%
IF %ERRORLEVEL% NEQ 0 (
	GOTO SQLPLUS_NO_EXISTEIX
)

rem set /p NLS_LANG=Indiqui el joc de caracters de la base de dades (NLS_LANG): 
set NLS_LANG=CATALAN_CATALONIA.WE8MSWIN1252

REM Es pregunten les dades de connexi a l' usuari 
set RETORN_PREGUNTAR_CONNEXIO_BD=POST_PREGUNTAR_CONNEXIO_BD
GOTO PREGUNTAR_CONNEXIO_BD
:POST_PREGUNTAR_CONNEXIO_BD

REM Es verifica la connectivitat amb la base de dades 
set RETORN_VERIFICAR_CONNEXIO_BD=POST_VERIFICAR_CONNEXIO_BD
GOTO VERIFICAR_CONNEXIO_BD
:POST_VERIFICAR_CONNEXIO_BD

REM Es verifica el propietari dels objectes 
set RETORN_PROPIETARI_OBJECTES=POST_PROPIETARI_OBJECTES
GOTO PROPIETARI_OBJECTES
:POST_PROPIETARI_OBJECTES

REM Es verifica la existncia del tablespace de taules 
set RETORN_VERIFICAR_TABLESPACE_TAB=POST_VERIFICAR_TABLESPACE_TAB
GOTO VERIFICAR_TABLESPACE_TAB
:POST_VERIFICAR_TABLESPACE_TAB

REM Es verifica la existncia del tables de ndexs
set RETORN_VERIFICAR_TABLESPACE_IND=POST_VERIFICAR_TABLESPACE_IND
GOTO VERIFICAR_TABLESPACE_IND
:POST_VERIFICAR_TABLESPACE_IND

REM Es revisa si la base de dades t activada la opci de particionament 
:PARTICIONAMENT
set RETORN_VERIFICAR_BD_PARTICIONADA=REVISAR_PARTICIONAMENT
GOTO VERIFICAR_BD_PARTICIONADA 

:REVISAR_PARTICIONAMENT
IF "%BD_PARTICIONADA%"=="TRUE" (
	GOTO PREGUNTAR_PARTICIONAMENT
)

:POST_REVISAR_PARTICIONAMENT
IF "%PARTICIONAR_TAULES%"=="S" (
	set RETORN_VERIFICAR_TABLESPACE_PART=POST_VERIFICAR_TABLESPACE_PART
	GOTO VERIFICAR_TABLESPACE_PART
	:POST_VERIFICAR_TABLESPACE_PART
	set SCRIPT_CREACIO_TAULES=%PATH_ACTUAL%scripts\taules\scripts_taules_particionades.sql
) else (
	set SCRIPT_CREACIO_TAULES=%PATH_ACTUAL%scripts\taules\scripts_taules_no_particionades.sql
)

REM Creaci d' usuari 
ECHO Preparant usuari de base de dades %USUARI_BD%
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%SCRIPT_CREACIO_USUARI% %USUARI_BD% %TABLESPACE_TAULES% >> %LOG_INSTALACIO%

REM Directoris de BD
ECHO Creant directoris de Base de dades 
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%SCRIPT_DIR_BD% %PATH_ACTUAL%Dades %USUARI_BD% >> %LOG_INSTALACIO%

REM Creaci de taules  
ECHO Creant taules 
IF "%TABLESPACE_PARTICIONS%"=="" (
	%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%SCRIPT_CREACIO_TAULES% %PATH_ACTUAL%scripts\taules %USUARI_BD% %TABLESPACE_TAULES% %TABLESPACE_INDEXS% >> %LOG_INSTALACIO%
) else (
	%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%SCRIPT_CREACIO_TAULES% %PATH_ACTUAL%scripts\taules %USUARI_BD% %TABLESPACE_TAULES% %TABLESPACE_INDEXS% %TABLESPACE_PARTICIONS% >> %LOG_INSTALACIO%
)


REM Creaci de vistes
ECHO Creant vistes 
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%SCRIPT_CREACIO_VISTES% %PATH_ACTUAL%scripts\vistes %USUARI_BD% >> %LOG_INSTALACIO%

REM Creaci de disparadors  
ECHO Creant disparadors  
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%SCRIPT_CREACIO_DISPARADORS% %PATH_ACTUAL%scripts\disparadors %USUARI_BD% >> %LOG_INSTALACIO%

REM Creaci de paquets 
ECHO Carregant codi PL/SQL
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%SCRIPT_CREACIO_PAQUETS% %PATH_ACTUAL%scripts\paquets %USUARI_BD% >> %LOG_INSTALACIO%
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%SCRIPT_RECOMPILAR_PAQUETS% %USUARI_BD% >> %LOG_INSTALACIO%

REM Carregant parmetres 
ECHO Carregant parmetres 
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%SCRIPT_PARAMETRES% %PATH_ACTUAL%scripts\parametres %USUARI_BD% >> %LOG_INSTALACIO%

GOTO SORTIR

:SQLPLUS_NO_EXISTEIX
echo No s' ha trobat el SQLPLUS en la ruta especificada. ORACLE_HOME\bin=%ORACLE_HOME%\bin
GOTO SORTIR

:PREGUNTAR_PARTICIONAMENT
set /p PARTICIONAR_TAULES=Vol aplicar particionament a les taules? (S/N):
IF "%PARTICIONAR_TAULES%"=="S" (
	GOTO POST_REVISAR_PARTICIONAMENT
)

IF "%PARTICIONAR_TAULES%"=="N" (
	GOTO POST_REVISAR_PARTICIONAMENT
)

GOTO REVISAR_PARTICIONAMENT

:VERIFICAR_BD_PARTICIONADA
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%RUTA_SELECTS%\bd_particionada.sql %RUTA_SELECTS%\bd_particionada.out >> %LOG_INSTALACIO%
set /p BD_PARTICIONADA=< %RUTA_SELECTS%\bd_particionada.out
del %RUTA_SELECTS%\bd_particionada.out
GOTO %RETORN_VERIFICAR_BD_PARTICIONADA%

:VERIFICAR_TABLESPACE_TAB
set /p TABLESPACE_TAULES=Indiqui el nom del tablespace on han de residir les taules a crear: 
IF "%TABLESPACE_TAULES%"=="" (
	GOTO VERIFICAR_TABLESPACE_TAB
)
echo Verificant existencia del tablespace %TABLESPACE_TAULES%
rem echo %DIR_SQLPLUS% -s -l %CONEXIO_BD% @%RUTA_SELECTS%\tablespace_ok.sql %RUTA_SELECTS%\tablespace_ok.out %TABLESPACE_TAULES% >> %LOG_INSTALACIO%
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%RUTA_SELECTS%\tablespace_ok.sql %RUTA_SELECTS%\tablespace_ok.out %TABLESPACE_TAULES% >> %LOG_INSTALACIO%
set /p TABLESPACE_TAB_OK=< %RUTA_SELECTS%\tablespace_ok.out
IF "%TABLESPACE_TAB_OK%" EQU "S" (
	echo Validacio superada
) ELSE (
	echo No existeix cap tablespace amb el nom %TABLESPACE_TAULES%
	GOTO VERIFICAR_TABLESPACE_TAB
)
del %RUTA_SELECTS%\tablespace_ok.out
GOTO %RETORN_VERIFICAR_TABLESPACE_TAB%

:VERIFICAR_TABLESPACE_IND
set /p TABLESPACE_INDEXS=Indiqui el nom del tablespace on han de residir els indexs a crear: 
IF "%TABLESPACE_INDEXS%"=="" (
	GOTO VERIFICAR_TABLESPACE_IND
)
echo Verificant existencia del tablespace %TABLESPACE_INDEXS%
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%RUTA_SELECTS%\tablespace_ok.sql %RUTA_SELECTS%\tablespace_ok.out %TABLESPACE_INDEXS% >> %LOG_INSTALACIO%
set /p TABLESPACE_IND_OK=< %RUTA_SELECTS%\tablespace_ok.out
IF "%TABLESPACE_IND_OK%" EQU "S" (
	echo Validacio superada
) ELSE (
	echo No existeix cap tablespace amb el nom %TABLESPACE_INDEXS%
	GOTO VERIFICAR_TABLESPACE_IND
)
del %RUTA_SELECTS%\tablespace_ok.out
GOTO %RETORN_VERIFICAR_TABLESPACE_IND%

:VERIFICAR_TABLESPACE_PART
set /p TABLESPACE_PARTICIONS=Indiqui el nom del tablespace on han de residir les partitions: 
IF "%TABLESPACE_PARTICIONS%"=="" (
	GOTO VERIFICAR_TABLESPACE_PART
)
echo Verificant existncia del tablespace %TABLESPACE_PARTICIONS%
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%RUTA_SELECTS%\tablespace_ok.sql %RUTA_SELECTS%\tablespace_ok.out %TABLESPACE_PARTICIONS% >> %LOG_INSTALACIO%
set /p TABLESPACE_PART_OK=< %RUTA_SELECTS%\tablespace_ok.out
IF "%TABLESPACE_PART_OK%" EQU "S" (
	echo Validaci superada
) ELSE (
	echo No existeix cap tablespace amb el nom %TABLESPACE_PARTICIONS%
	GOTO VERIFICAR_TABLESPACE_PART
)
del %RUTA_SELECTS%\tablespace_ok.out
GOTO %RETORN_VERIFICAR_TABLESPACE_PART%

:PROPIETARI_OBJECTES
set /p USUARI_BD=Indiqui l' usuari en el que s' han de crear els objectes: 
IF "%USUARI_BD%"=="" (
	GOTO PROPIETARI_OBJECTES
)
echo Verificant existencia de l' usuari %USUARI_BD%
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%RUTA_SELECTS%\usuari_bd_ok.sql %RUTA_SELECTS%\usuari_bd_ok.out %USUARI_BD% >> %LOG_INSTALACIO%
set /p USUARI_BD_OK=< %RUTA_SELECTS%\usuari_bd_ok.out
IF "%USUARI_BD_OK%" EQU "S" (
	echo Validacio superada
) ELSE (
	echo No existeix cap usuari amb el nom %USUARI_BD%
	GOTO PROPIETARI_OBJECTES
)
del %RUTA_SELECTS%\usuari_bd_ok.out
GOTO %RETORN_PROPIETARI_OBJECTES%


:VERIFICAR_CONNEXIO_BD
echo Verificant connectivitat amb la base de dades %SID_BD%
%DIR_SQLPLUS% -s -l %CONEXIO_BD% @%RUTA_SELECTS%\connexio_bd.sql %RUTA_SELECTS%\connexio_bd.out >> %LOG_INSTALACIO%
set /p CONNEXIO_BD_OK=< %RUTA_SELECTS%\connexio_bd.out
del %RUTA_SELECTS%\connexio_bd.out

IF "%CONNEXIO_BD_OK%" EQU "S" (
	echo Validacio superada
) ELSE (
	echo ERROR: Les dades de connexio no son correctes o be la base de dades %SID_BD% no es accessible.
	set RETORN_PREGUNTAR_CONNEXIO_BD=VERIFICAR_CONNEXIO_BD
	GOTO PREGUNTAR_CONNEXIO_BD
)
GOTO %RETORN_VERIFICAR_CONNEXIO_BD%

:PREGUNTAR_CONNEXIO_BD
set /p SID_BD=Indiqui la connexio a la BD on vol fer la instal.lacio: 
set /p SYSTEM_PASSWORD=Introdueixi la contrasenya de l' usuari SYS: 
set CONEXIO_BD=SYS/"%SYSTEM_PASSWORD%"@%SID_BD% AS SYSDBA
GOTO %RETORN_PREGUNTAR_CONNEXIO_BD%

:SORTIR
ECHO Instal.lacio finalitzada correctament
pause