create or replace view vtfc_ven_bot as
Select ven.NUMANY,
       ven.MES,
       BOT.IDEBOT,
       BOT.NOMBOT,
       BOT.CIU_IDECIU,
       BOT.NUMTRBACT,
       ven.QNTVEN,
       ven.COUNT_PRO,
       ven.BENNET,
       --Round(Nvl(Ratio_To_Report(BENNET) OVER (), 0) * 100, 2) as PER_BENNET,
       Sum(ven.BENNET) over (partition by ven.NUMANY, ven.MES) as BENNET_TOTAL_MES_ANY,
       (ven.BENNET / bot.NUMTRBACT) as BENNET_TRB
  from (Select tem.INA_NUMANY AS NUMANY,
               tem.MES,
               Sum(ven.QNTVEN) as QNTVEN,
               Count(distinct ven.PRO_CODEAN13) as COUNT_PRO,
               Sum(ven.BENNET) as BENNET,
               ven.BOT_IDEBOT
          from TFC_VENDES   ven,
               TFC_TEMPS    tem
          where ven.TEM_DATA   = tem.DATA and
                ven.TEM_HORA   = tem.HORA
          group by tem.INA_NUMANY,
                   tem.MES,
                   ven.BOT_IDEBOT) ven,
        TFC_BOTIGUES bot
  where ven.BOT_IDEBOT = bot.IDEBOT;
